#ifndef ADVANCEDCONFIG_H
#define ADVANCEDCONFIG_H

#include "manageserialport.h"

class AdvancedConfigWindow : public QWidget
{
    Q_OBJECT
public:
    explicit AdvancedConfigWindow(ManageSerialPort *_serialPort, vector<Module> *_moduleList,QWidget *parent = 0);
    void refreshCursorPosition();

signals:
    void closingWindow();
//    void timeout_cfg();

public slots:
   /* void mousePressEvent(QMouseEvent *)
    {
        emit timeout_cfg();
    }*/

private slots:
    void ReadAndShowResponse();
    void WriteAndShowResponse();
    void testMemM();
    void testMemC();

    void test_lora_com();

    void updateModuleListFromCentral();

    bool writedata(uint32_t serialNb,uint32_t address,uint8_t datatowrite);
    void pointerSliderMoved(int _newPosition);
    void pointerButtonPushed();
    void pointerButtonmanPushed();
    void closeEvent(QCloseEvent *event);
    void send_file_clicked();
    void sendFirm();
    bool update_wifi();
    void update_adress_firm();
    void update_module_firm();
    void update_status_line(QString status_line);
    void setMemoryConfig(int config); //0 : single memory, 1 : double memory
        void write_param_file();

private :
     bool litr(uint32_t serial);
    bool ecrit5(uint32_t serial, uint8_t value[]);
    bool ecrit12(uint32_t serial, uint8_t value[]);

    uint8_t calc_checksum(QByteArray in);
    QByteArray make_set_data_frame(uint32_t file_length,uint16_t n_sector, uint32_t start_address);
    bool sendWifiFrame(QByteArray data);
    QByteArray make_data_frame(QByteArray data, uint16_t sector);
    QByteArray replacechar(QByteArray in);
    int sendFileWifi(uint8_t i_file, QDir folder);
    ManageSerialPort *serialCom;
    vector<Module> *moduleList;
    uint32 endOfMemory;
    void fillWindow();
    QSettings *settingFile;
    bool WriteHexFile(uint32_t serialNb,uint32_t address, bool mode_envoi);
    void update_module_firmware(bool mode_write);

 //GUI
    //read section :
    QLineEdit *serialNbLine;
    QLineEdit *addressLine;
    QSpinBox *nbDataBox;
    QPlainTextEdit *dataReadDisplay;

    // write section :
    QLineEdit *serialNbLineWrite;
    QLineEdit *addressLineWrite;
    QSpinBox *valueToWrite;
    QLabel *receivedWritingLabel;
    QComboBox *select_function;

    //move pointer section :
    QLabel *pointerPosition;
    QSlider *pointerSlider;
    QPushButton *pointerMoveButton;
    QLineEdit *pointeurvalue;
    QPushButton *pointerMovemanButton;

    QComboBox *memoryconfig;

    QLabel *write_firm_status;

    QLabel *testLoraStatus;

    bool updating_wifi;
    bool abort_wifi;
    QPushButton *testfirm;
    QLabel *write_wifi_status;
    QProgressBar *write_wifi_prog;

    QPushButton *changeadd_firmmodule;
    QPushButton *writfirmmodule;
    QComboBox *mode_firmware_module;
    QComboBox *select_address_firmware;
    QLineEdit *serialNbupdate;
    QLabel *write_firm_module_status;


    QPlainTextEdit *moduleListView;
    QTextEdit *c_memtest;
};

#endif // ADVANCEDCONFIG_H
