#ifndef ADVANCEWIRELLESSSENSOR_H
#define ADVANCEWIRELLESSSENSOR_H

#include "qextserialenumerator.h"
#include "manageserialport.h"



class AdvanceWirellessSensor: public QWidget
{
    Q_OBJECT
public:
    explicit AdvanceWirellessSensor(ManageSerialPort *_serialPort, Sensor_l _sensor, QWidget *parent = 0);
    ~AdvanceWirellessSensor();
private:
    uint16_t address_file;
    QSettings *settingFile;
    void fillWindow();
    bool read_active;
    bool write_active;
    bool program_active;
    bool save_file_active;
    bool toggle;
    ManageSerialPort *serialCom;
    Sensor_l sensor;
    bool flag_timeout;
    QTimer *timer1;
    QTimer *timer2;
    //GUI
    QLabel *sensor_sn;
    QLineEdit *addressLine;
    QComboBox *select_memory;
    QPushButton *sendReadOrderButton;
    QPushButton *record_file;
    QLineEdit *dataReadDisplay;
    QLineEdit *addressLineWrite;
    QLineEdit *valueToWrite;


    QCheckBox *reset_chip;
    QPushButton *writeButton;
    QPushButton *writfirmsensor;
    QLabel *write_firm_sensor_status;
    QFile  *sav_file;



    void SendAction();
    void send_param();
    void save_to_file();
    bool add_sensor_to_list(uint16_t _sensor_nr);
    void program_sensor();



signals:
    void AdvanceClosed();

private slots:
    void closeEvent(QCloseEvent *event);
    void ReadClicked();
    void SaveFileClicked();
    void WriteClicked();
    void timeout();
    void each_sec();
    void ProgramClicked();
};

#endif // ADVANCEWIRELLESSSENSOR_H

