#include "common.h"
#include "unistd.h"
// Common parameters & casting methods
 QDateTime current_time;
/*namespace
{

}*/


//**************************
//  Casting methods

// Place an unsigned int of 32bits in a uchar array
void placeUint32InUcharTab(uint32 inputUint32, uchar *ucharTab, int position)
{
    for(int i=0;i<4;i++)
    {
        ucharTab[position+3-i]=inputUint32%0x100;
        inputUint32/=0x100;
    }
}

// Place an unsigned int of 64bits in a uchar array
void placeUint64InUcharTab(uint64_t inputUint64, uchar *ucharTab, int position)
{
    for(int i=0;i<8;i++)
    {
        ucharTab[position+7-i]=inputUint64%0x100;
        inputUint64/=0x100;
    }
}
// Place an unsigned int of 16bits in a uchar array
void placeUint16InUcharTab(uint16 inputUint16, uchar *ucharTab, int position)
{
    for(int i=0;i<2;i++)
    {
        ucharTab[position+1-i]=inputUint16%0x100;
        inputUint16/=0x100;
    }
}


// Return the unsigned int of 32bits located from position in the uchar array, with MSB ending
uint32 peekUint32FromUcharTabBigEndian(uchar * _inputCharTab, int position)
{
    uint32 outputUint32=0;
    for(int i=0;i<4;i++)
    {
        (*((uint8_t*)&outputUint32+i))=_inputCharTab[position+i];
      //  outputUint32+=_inputCharTab[position+i]<<(i*8);
    }
    return outputUint32;
}

uint64_t peekUint48FromUcharTabBigEndian(uchar * _inputCharTab, int position)
{
    uint64_t outputUint48=0;
    for(int i=0;i<6;i++)
    {
        (*((uint8_t*)&outputUint48+i))=_inputCharTab[position+i];
    }
    return outputUint48;
}

uint32 peekInt32FromUcharTabBigEndian(uchar * _inputCharTab, int position)
{
    int32_t outputint32;
    for(int i=0;i<4;i++)
        (*((uint8_t*)&outputint32+i))=uint8_t(_inputCharTab[position+i]);
    return outputint32;
}


// Return the unsigned int of 32bits located from position in the uchar array, with LSB ending
uint32 peekUint32FromUcharTabLittleEndian(uchar * _inputCharTab, int position)
{
    uint32 outputUint32=0;
    (*((uint8_t*)&outputUint32))=_inputCharTab[position+3];
    (*((uint8_t*)&outputUint32+1))=_inputCharTab[position+2];
    (*((uint8_t*)&outputUint32+2))=_inputCharTab[position+1];
    (*((uint8_t*)&outputUint32+3))=_inputCharTab[position];
    return outputUint32;
}



// Return the unsigned int of 16bits located from position in the uchar array, with MSB ending
uint16 peekUint16FromUcharTabBigEndian(uchar * _inputCharTab, int position)
{
    uint16 outputUint16=0;
    for(int i=0;i<2;i++)
        (*((uint8_t*)&outputUint16+i))=uint8_t(_inputCharTab[position+i]);
    return outputUint16;
}

int16 peekInt16FromUcharTabBigEndian(uchar * _inputCharTab, int position)
{
   // uint16 outputUint16=0;
    int16_t outputint16;
    for(int i=0;i<2;i++)
        (*((uint8_t*)&outputint16+i))=uint8_t(_inputCharTab[position+i]);
    return outputint16;
}

int16 peekInt16FromUcharTabLittleEndian(uchar * _inputCharTab, int position)
{
   // uint16 outputUint16=0;
    int16_t outputint16;
    (*((uint8_t*)&outputint16+1))=uint8_t(_inputCharTab[position]);
    (*((uint8_t*)&outputint16))=uint8_t(_inputCharTab[position+1]);
    return outputint16;
}


int8_t peekInt8FromUcharTab(uchar * _inputCharTab, int position)
{
    int8_t outputint8;
    (*((uint8_t*)&outputint8))=uint8_t(_inputCharTab[position]);
 /*   if(_inputCharTab[position]>32767) outputint8=256-_inputCharTab[position];
    else outputint8=_inputCharTab[position];*/
    return outputint8;
}



// Return the unsigned int of 16bits located from position in the uchar array, with LSB ending
uint16 peekUint16FromUcharTabLittleEndian(uchar * _inputCharTab, int position)
{
    uint16 outputUint16=0;
    (*((uint8_t*)&outputUint16+1))=uint8_t(_inputCharTab[position]);
    (*((uint8_t*)&outputUint16))=uint8_t(_inputCharTab[position+1]);
    /*
    outputUint16=uint16(_inputCharTab[position]<<8);
    outputUint16+=uint16(_inputCharTab[position+1]);*/
    return outputUint16;
}

//convert an uchar decimal to an uchar BCD coded
uchar bcdFromDecimal(uchar _value)
{
    return (((_value/10)<<4)+(_value % 10));
}

// Return a 12 uchar vector from position, in another vector
vector<uchar> peek12ucharFromVector(vector<uchar> _inputVector, uint32 position)
{
    vector<uchar> outputVector;
    if(_inputVector.size()>=uint32(position+12))
    {
        for(uint32 index=0; index<12; index++)
        {
            outputVector.push_back(_inputVector[index+position]);
        }
    }
    return outputVector;
}

// Return the unsigned int of 16bits located from position in the uchar vector, with MSB ending
// for campaign download
uint16 peekUint16FromVectorBigEndian(vector<uchar> _inputVector, int position)
{
    uint16 outputUint16=0;
    if(_inputVector.size()>=uint32(position+2))
    {
        (*((uint8_t*)&outputUint16))=uint8_t(_inputVector[position]);
        (*((uint8_t*)&outputUint16+1))=uint8_t(_inputVector[position+1]);
       /* outputUint16=uint16(_inputVector[position]);
        outputUint16+=uint16(_inputVector[position+1]<<8);*/
        return outputUint16;
    }
    // error
    return 0;
}

uint32 peekUint32FromVectorBigEndian(vector<uchar> _inputVector, int position)
{
    uint32 outputUint32=0;
    if(_inputVector.size()>=uint32(position+4))
    {
        (*((uint8_t*)&outputUint32))=uint8_t(_inputVector[position]);
        (*((uint8_t*)&outputUint32+1))=uint8_t(_inputVector[position+1]);
        (*((uint8_t*)&outputUint32+2))=uint8_t(_inputVector[position+2]);
        (*((uint8_t*)&outputUint32+3))=uint8_t(_inputVector[position+3]);
     /*   outputUint32=uint32(_inputVector[position]);
        outputUint32+=uint32(_inputVector[position+1]<<8);
        outputUint32+=uint32(_inputVector[position+2]<<16);
        outputUint32+=uint32(_inputVector[position+3]<<24);*/
        return outputUint32;
    }
    // error
    return 0;
}

//******************************
//  Pause

void waitFor(int msec)  // Make a pause and wait for msec milliseconds
{
  //  long temporaryWaiting=clock();
//    qDebug()<<"pause : before loop, ticks = "<<temporaryWaiting;

//#ifdef _TTY_WIN_
   /* while(long(clock()-temporaryWaiting)<long(msec*1000/CLOCKS_PER_SEC))
    {
        QCoreApplication::processEvents(QEventLoop::ExcludeUserInputEvents,msec);
        //TODO : find a way to limit number of process event
    }*/
//#else
QCoreApplication::processEvents(QEventLoop::ExcludeUserInputEvents,msec);
usleep(msec*1000);
//#endif

//    qDebug()<<"pause ("<<msec<<") was during "<<long((clock()-temporaryWaiting)*1000/CLOCKS_PER_SEC)<<"ms, ticks = "<<clock();
}

void waitForUs(int usecs)  // Make a pause and wait for usec microseconds
{

QCoreApplication::processEvents(QEventLoop::ExcludeUserInputEvents,usecs);
usleep(usecs);

}

//******************************
//  Debug

// Return a hexadecimal format string
// Ex: convert {0xD3,0xBB,...,0x02} to "d3bb...02"
string uchar2hexString(uchar * ucharToConvert, int _length)
{
    string hexString;
    const char hexval [16] = {'0', '1', '2', '3', '4', '5',
            '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};

    for(int i=0; i<_length; i++)
    {
        hexString+=hexval[((ucharToConvert[i]>>4)&0xF)];
        hexString+=hexval[(ucharToConvert[i]&0x0F)];
    }
    return hexString;
}

void displayUcharTab(uchar *_UcharTab, int _length)
{   //Display an uchar array in the qDebug output
    QString debugLine = "display Tab (l="+QString::number(_length)+") : ";
    for(int i=0; i<_length;i++) debugLine += QString::number(_UcharTab[i],16).rightJustified(2,'0')+" ";
    qDebug()<<debugLine;
}

void displayCharTab(char *_CharTab, int _length)
{   //Display a char array in the qDebug output
    QString debugLine = "display Tab (l="+QString::number(_length)+") : ";
    for(int i=0; i<_length;i++) debugLine += QString::number(uchar(_CharTab[i]),16).rightJustified(2,'0')+" ";
    qDebug()<<debugLine;
}

void debugDisplayVector(vector<uchar> vectorToPrint)
{   //Display an uchar vector in the qDebug output
    QString line;
    for(uint32 y=0; y<vectorToPrint.size(); y++)
    {
        line+=QString::number(vectorToPrint[y],16).rightJustified(2,'0')+" ";
    }
    qDebug()<<line;
}


void debugDisplayQByteArray(QByteArray _byteArray)
{   //Display an QByteArray in the qDebug output
    QString line;
    for(int y=0; y<_byteArray.size(); y++)
    {
        line+=QString::number((uint8_t)_byteArray.at(y),16).rightJustified(2,'0')+" ";
    }
    qDebug()<<line;
}

QString serial_to_string(uint32_t serial_nb)
{
    if(serial_nb<0x10000)
    {
        return QString::number((uint16_t)serial_nb,16).rightJustified(4,'0').toUpper();
    }
    else return QString::number(serial_nb,16).rightJustified(8,'0').toUpper();
}

void refresh_events()
{
#ifdef NO_GUI
        QCoreApplication::processEvents();
#else
        QApplication::processEvents();
#endif

}
