#ifndef FRAME_RELAY_H
#define FRAME_RELAY_H

#include "qextserialenumerator.h"
#include "manageserialport.h"

class frame_relay :  public QWidget
{
    Q_OBJECT
public:
    explicit frame_relay(ManageSerialPort *_serialPort, QWidget *parent = 0);

private:
    QSettings *settingFile;
    bool tab_relay [48] [48];
    bool tab_sensor [48];
    uint8_t nb_of_sensor;
    uint8_t nb_of_plug;
    uint16_t list_sensor[48];
    uint16_t list_plug[48];
    void fillWindow();
    ManageSerialPort *serialCom;
    QTableWidget *table_sensor;
    QStringList list_plug_str;

    //GUI
    QVBoxLayout *verticalLayout;
    QPushButton *refresh_button;
    QPushButton *reset_button;

private slots:
    void closeEvent(QCloseEvent *event);
    void fill_table();
    void cell_clicked(int row,int col);
    void column_clicked(int col);
    void refresh_clicked();
    void reset_clicked();


signals:
    void relayClosed();

public slots:

};

#endif // FRAME_RELAY_H
