#ifndef MAINWINDOW_H
#define MAINWINDOW_H

//#include <Qt/QMainWindow>
//#include "http_server.h"
#include "manageserialport.h"
#include "connectiondialog.h"
#include "advancedconfig.h"
#include "managemodule.h"
#include "gprsconfig.h"
#include "ethernetconfig.h"
#include "frame_relay.h"
//#include "simle_http.h"
#include "common.h"
#include "refreshtimer.h"
#ifdef _TTY_POSIX_
#include "PCD8544.h"
#include <wiringPi.h>
#include "c_function.h"
#endif

#define ADVMODE_PASSWORD "0000" //Password to accept advanced Mode

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void tryToOpenPort();

signals:
    void openingOtherWindow();
    void closingOtherWindow();
    void advancedUserModeEnabled();
    void timer_config_reinit();

public slots:
    void clearTitleCentralDisplay();
        void refresh_pause_button();
    /*void mouve_mouse()
    {
        if(mode_server)
        {
            emit timer_config_reinit();
        }
    }*/

private slots:
    void dummy(){

    }
    void auto_d_ok(){
       ad_ok=true;
    }
        void init_window();

        void refresh_display();

//    void openConnectionWindow();
    void openAdvancedConfigWindow();
    void openGprsConfigWindow();
    void openEthernetConfigWindow();
  //  void openHttpserver();
  //  void req_ftp();
   /* void timeout_server()
    {
        waitFor(200);
        openHttpserver();
        waitFor(200);
    }*/

    void openRelayWindow();
    void displayErrorOfCommunication();
    void displayNoErrorOfCommunication();
    void displayComClose();
    void returnFromAdvConfig();
    void returnFromGprs();
    void returnFromConnectionDialog();
    void returnFromEthernetConfigWindow();
    void returnFromRelayWindow();
   // void returnFromserver();
    void switchPauseRefresh();
    void com_open();
    void closeEvent(QCloseEvent *event);
   // void mousePressEvent(QMouseEvent *);

private:
    bool display_mode;
    bool connect_cfg_opened;
    uint16_t add_api;
    QString current_label;
    bool ad_ok;
   // bool ftp_req;
    int check_setting_file(QString filename);
    bool invalid_setting_file;
  /*  HttpSimple *simple_http;
    HttpDaemon *server;*/
  //  bool mode_server;
    uint32_t sn_display;
    QLabel *power_channel[6];
    QLabel *channel_id[6];
    QLabel *channel_title[6];
    int coef_mul[6];
    int coef_div[6];
    frame_relay *relayWindow;
    QTimer *displayTimer;
     bool config_pass_ok;
    bool first_connect;
    ManageSerialPort *serialCom;
    ManageModule *mainFrame;
    ConnectionDialog *connectionDialogWindow;
    AdvancedConfigWindow *advConfigWindow;
    GprsConfig *gprsConfigWindow;
    EthernetConfig *ethernetConfigWindow;
    vector<Module> *moduleList;  //to pass list from ManageModule to Gprs
    RefreshTimer *commonRefreshTimer;
   // QTimer *timer_retry_com;
    QMenu *fileMenu;
    QMenu *configMenu;
    QAction *pauseRefreshAction;

    QSettings *settingFile;
    QLabel *comStatus;
    void init_display();

    void addMenus();
    void addStatusIcon();
    uint16 LastDL;
protected:
    void keyPressEvent(QKeyEvent *event);
};

#endif // MAINWINDOW_H
