#ifndef MANAGEWIRELESSDATA_H
#define MANAGEWIRELESSDATA_H

#include "qextserialenumerator.h"
#include "manageserialport.h"
#include <QxtWidgets/QxtCheckComboBox>
#include "advancewirellesssensor.h"
#define ADVMODE_PASSWORD "0000" //Password to accept advanced Mode
class managewirelessdata : public QWidget
{
    Q_OBJECT
public:
    explicit managewirelessdata(ManageSerialPort *_serialPort, QWidget *parent = 0);
    ~managewirelessdata();
    virtual bool winEvent( MSG* message, long* result );
    void reinit_window();

public slots:
    void valueChanged(int row, int column);
   // void valueClicked(int row, int column);

private:
    uint16_t current_relay;
    bool flag_timeout4;
    bool flag_refresh_relay;
    uint8_t nb_relay;
    UINT a;
    AdvanceWirellessSensor *AdvanceWindow;
    QSettings *settingFile;
    QSettings *exportFile;
    uint16_t address_api_old;
    bool flag_retry_dl;
    bool toggle;
    bool dl_in_progress;
    QTimer *timer1;
    QTimer *timer3;
    QTimer *timer_refresh_list;
//    vector < uchar>  DownloadedValues;
    bool deleting_row;
    bool fillingSensorTable;
    bool button_state_sa;
    bool button_state_ad;
    bool flag_timeout;
    bool flag_timeout2;
    bool rx_ok_when_dl;
    void fillWindow();
    void setTableWidget();
    void setSerialNb(int row);
    void updateTypeComboBoxList(int row,bool def);
    void delete_row(int row);
    ManageSerialPort *serialCom;
    uint8_t download_data(uint32_t sensor_nr);
    void recup_param(uint32_t sensor_nr,bool req_send);
    uint8_t send_param (uint32_t sensor_nr);
    void recup_start_end_page(uint32_t sensor_nr);
    bool add_sensor_to_list(uint32_t _sensor_nr);
    bool add_sensor_to_list_relay(uint32_t _sensor_nr,uint16_t _relay_sn);
    bool remove_sensor_to_list_relay(uint32_t _sensor_nr,uint16_t _relay_sn);
    bool add_sensor_to_list_det(uint32_t _sensor_nr);
    bool remove_sensor_to_list_det(uint32_t _sensor_nr);
    bool add_current_sensor(uint32_t _sensor_nr);
    bool add_current_sensor_relay(uint32_t _sensor_nr,uint16_t _relay_sn);
    bool remove_sensor_to_list(uint32_t _sensor_nr);
    bool dl_sensor_to_pages(uint32_t _sensor_nr,uint16_t st_page,uint16_t nb_page);
    bool dl_sensor_to_pages_relay(uint32_t _sensor_nr,uint16_t st_page,uint16_t nb_page,uint16_t _relay_sn);
    //uint8_t received_packet_buffer[4096];
    bool updateFile(uint32_t sensor_nr);//,uint8_t n_pages);

    void update_relay_info();

    bool openFile(uint32_t sensor_nr);
    void add_empty_row();
    void copy_sensor(Sensor_l dest,Sensor_l source);
    void req_sendaction();
    void req_detect_sensor();
    void get_data_to_send(uint16_t serial_nr);
    void init_color();
    void restore_color();
    QDir folder_for_save;
    QLineEdit *saving_folder;
    QFile tsvFile[256];
    QTextStream tsvFileStream[256];
    bool file_open[256];

    Relay list_relay[256];

    QStringList listTempHygroPulse;
    QStringList listTempPulse;
    QStringList listLamp;
    QStringList listWattmeter;

    QStringList listPeriode;

    long ecart_sec[256];
    Sensor_l sensorList [256];

    QStringList batt_volt,batt_volt2;
    QxtCheckComboBox *data_rec_ComboBoxList [256];
    QComboBox *periode_ComboBoxList [256];
    QCheckBox *legacy_mode[256];
    bool legacy_old[256];
    int index_periode[256];
    QStringList list_datarec[256];
    QLabel *sensor_data[256];
    bool start_time_change[256];
    bool current_time_change[256];
    bool data_rec_change[256];
    bool periode_change[256];
    bool set_change[256];
    bool legacy_changed[256];
    QTableWidgetItem *sensorItemTable [256][256] ;
    bool sensor_action_finished[256];
    uint8_t data_rec_to_send;
    uint8_t new_per;
    uint16_t ecart_set_time;
     bool folder_ok;
    QTimer *timer_dl;
     bool flag_dl_interrupt;

    //GUI :
    QVBoxLayout *verticalLayout;
    QTableWidget *sensorTableWidget;
    //QTableWidgetItem *delTableItem;
    QTableWidgetItem *sensorSNTableItem;
    QTableWidgetItem *sensorTypeTableItem;
    QTableWidgetItem *sensorVersionTableItem;
    QTableWidgetItem *sensorCurrentTimeTableItem;
    QTableWidgetItem *sensorStartTimeTableItem;
    QTableWidgetItem *sensorTypeDataRecTableItem;
    QTableWidgetItem *sensorPeriodeRecTableItem;
    QTableWidgetItem *sensorNbPageTableItem;
//    QTableWidgetItem *sensorClearTableItem;
   // QTableWidgetItem *sensorDLTableItem;
    QTableWidgetItem *sensorStatusTableItem;
    QTableWidgetItem *sensorVbatItem;
     QTableWidgetItem *sensorRSSITableItem;
     QTableWidgetItem *sensormodeTableItem;

    QLabel *current_pc_time;
    QLabel *relay_status;

    QGroupBox* action_box;

    QCheckBox *settime;
    QCheckBox *setperiode;
    QCheckBox *clrdata;
    QCheckBox *set_data_rec;
    QCheckBox *dl_all_data;
    QCheckBox *dl_data_between;
    QDateTimeEdit *dl_start_time;
    QDateTimeEdit *dl_end_time;

    QPushButton *send_action;
    QPushButton *detect_sensor;
    QPushButton *select_folder;

    QPushButton *Import_list;
    QPushButton *Export_list;


private slots:
    void closeEvent(QCloseEvent *event);
    void time_out_dl();
    void timeout4();
    void refresh_relay();
    void displayContextMenu(const QPoint &pos);
    void time_out();
    void each_sec();
    void open_window();
    void button_detect_sensor_clicked();
    void button_send_action_clicked();
    void button_select_folder_clicked();
    void button_import_clicked();
    void button_export_clicked();
    void state_change_dl_all_data();
    void state_change_dl_data_between();
    void state_change_clrdata();
    void state_change_setperiode();
    void state_change_set_data();
    void state_change_set_time();
    void periode_changed();
    void datarec_changed();
    void legacy_mode_changed();
    void folder_changed(QString folder);
    void adv_config_closed();


signals:
    void wirelessClosed();
    void req_stop_rx();
    void button_sa_clicked();

protected:
  void keyPressEvent(QKeyEvent * event);

};





#endif // MANAGEWIRELESSDATA_H
