#ifndef PRESSTEMPMODULE_H
#define PRESSTEMPMODULE_H

#include "manageserialport.h"
#include "refreshtimer.h"
class PressTempModule : public QWidget
{
    Q_OBJECT
public:
    explicit PressTempModule(ManageSerialPort *_serialPort, RefreshTimer *_commonRefreshTimer, Module *_module, QWidget *parent = 0);
    ~PressTempModule();

signals:
    void backToMainWindow();
   // void timeout_cfg();

public slots:
  /*  void mousePressEvent(QMouseEvent *)
    {
        emit timeout_cfg();
    }*/
    void startTimerAgain();

private slots:
    void timerSlot();
    void sendNewName(int _channel);
    void backToManageModule();

private:
    ManageSerialPort *serialCom;
    RefreshTimer *commonRefreshTimer;
    Module *module;
    int currentChannel;
    bool updateChannelNames();
    bool channelNamesUpdated;
    QSignalMapper *channelNamesSignalMapper;

    //graphics elements :
    void fillWindow();
    QVBoxLayout *globalLayout;
    QGroupBox *groupBoxModule;
        QVBoxLayout *verticalLayout;
            QLabel *moduleSNLabel;
            QGridLayout *channelGridLayout;
                vector< QLineEdit *> channelNamesVector;
                vector< QLabel *> channelValuesVector;
            QHBoxLayout *buttonLayout;
                QPushButton *returnButton;
};

#endif // PRESSTEMPMODULE_H
