#include "refreshtimer.h"
//#include <QDebug>
//Constructor
  extern bool refreshIsPaused;
RefreshTimer::RefreshTimer(QObject *parent) :
    QObject(parent)
{
    //Init Timer
    refreshTimer=NULL;
    interval=800;
    smallInterval=150;
    refreshTimer = new QTimer;
    refreshTimer->setSingleShot(true);

    //Get config.ini values (intervals)
    QSettings *settingFile = new QSettings(QString(DEFAULT_DIR)+"config.ini",QSettings::IniFormat);
    if(settingFile->contains("TIMER/INTERVAL"))
        interval=settingFile->value("TIMER/INTERVAL").toInt();
    if(settingFile->contains("TIMER/SMALL_INTERVAL"))
        smallInterval=settingFile->value("TIMER/SMALL_INTERVAL").toInt();
}

//Destructor
RefreshTimer::~RefreshTimer()
{
    refreshTimer->stop();
    refreshTimer->disconnect();
    delete refreshTimer;
}

//Change timer connection
void RefreshTimer::connectTimeout(QObject *_object)
{
    refreshTimer->stop();
    refreshTimer->disconnect();
    connect(refreshTimer,SIGNAL(timeout()),_object,SLOT(timerSlot()));
}

//stop and disconnect all
void RefreshTimer::disconnectTimeout()
{
    refreshTimer->stop();
    refreshTimer->disconnect();
}

//Start Timer with specified interval in msec
void RefreshTimer::start(int _interval)
{
    if(refreshIsPaused) return;
 //   qDebug()<<"timer start custom";
    refreshTimer->stop();
    refreshTimer->start(_interval);
}

//Start Timer with interval
void RefreshTimer::startInterval()
{
    if(refreshIsPaused) return;
 //   qDebug()<<"timer start standard";
    refreshTimer->stop();
    refreshTimer->start(interval);    //ms
}

//Start Timer with small interval
void RefreshTimer::startSmallInterval()
{

    if(refreshIsPaused) return;
  //  qDebug()<<"timer start small";
    refreshTimer->stop();
    refreshTimer->start(smallInterval);    //ms
}

//Stop Timer
void RefreshTimer::stop()
{
    refreshTimer->stop();
}

//Restart after pause
void RefreshTimer::restartAfterPause()
{
  //  int previousInterval = refreshTimer->interval();
   // refreshTimer->start(previousInterval);
      refreshTimer->start(smallInterval);    //ms
}
