#ifndef SERIALFRAME_H
#define SERIALFRAME_H

// special chars
#define START_OF_FRAME_API 0x7E
#define START_OF_FRAME 0xC0
#define END_OF_FRAME 0xC1
#define ESCAPE_CHAR 0x7D
#include "common.h"

class SerialFrame
{
public:
    uint64_t address_API;
    connectionType typeOfConnection;
    //Constructors + destructor
    SerialFrame();
    ~SerialFrame();
    //Getters
    uchar * getFrame() const;
    int getLength() const;
    uchar * getData();
    uchar * getAllData();
    int getDataLength();

    //Setters
    void changeFrame(char *_frame, int _length);

    //Make frame
    void makeReadFrame(uint32 serialNb, uint32 address, uchar nbToRead);
    void makeWriteFrame(uint32 serialNb, uint32 address, uchar value);
    void makeWriteFrameS(uint32 serialNb, uint32 address, uchar value);
    void makeWriteFrame4(uint32 serialNb, uint32 address, uchar value[4]);

    void makeframe_wdata(uint32 serialNb,uchar function,uchar param[17], uint16_t address_API);
    void makeSimpleAPIFrame(QByteArray data_to_send);
    int validateReceivedwdata();
    int validateReceived(uint32 sendSerialNb, uint32 sendAddress,uchar req_length);
    void makeFrameAPI(QByteArray _data,uint16_t address_API);
    //Erase frame / allocate
    void erase();
    void allocate(int _length);

    //Debug
    void display();


private:
    uchar *frame;
    int length;
    //copy
    uchar *copy(const uchar *_frame, int _length);

    //CRC
    uint16 computeCrc(uchar *_frame,int start_pos, int _length);
    bool checkCRC();

    //Check special char (7D, C0, C1)
    void check_special_char_in_received_frame(int start_pos,int end_pos);
    void check_special_char_in_frame_to_send();

    //API Checksum
    uint16 ComputeChecksum();

    //make
    void makeFrame(QByteArray _data);

    void makeFrameAPI868(QByteArray _data,uint64_t address_API);

 //   void makeFrame4(QByteArray _data);
//    void makeFrame4API(QByteArray _data,uint16_t address_API);


};

#endif // SERIALFRAME_H
