#ifndef WAVEFORM_H
#define WAVEFORM_H

#include "common.h"
#include "qextserialenumerator.h"
#include "manageserialport.h"
#include "refreshtimer.h"
#include <qwt_plot.h>
#include <qwt_plot_marker.h>
#include <qwt_plot_curve.h>
#include <qwt_legend.h>
#include <qwt_series_data.h>
#include <qwt_plot_canvas.h>
#include <qwt_plot_panner.h>
#include <qwt_plot_magnifier.h>
#include <qwt_text.h>
#include <qwt_math.h>

class Plot :  public QwtPlot
{
Q_OBJECT
public:
    explicit Plot( QWidget *parent = 0);
    QwtPlotCurve *u_curve;
    QwtPlotCurve *i_curve;



private:


private slots:

};

class waveform :  public QWidget
{
Q_OBJECT
public:
    explicit waveform(ManageSerialPort *_serialPort,RefreshTimer *_commonRefreshTimer,Module *_power_module,int _current_channel,float _coef_module, QWidget *parent = 0);

signals:
    void waveformClosed();

  //  void timeout_cfg();

public slots:
  /*  void mousePressEvent(QMouseEvent *)
    {
        emit timeout_cfg();
    }*/
private:
    bool ref_paused;
    QSettings *settingFile;
    Plot *plot;
    uint16_t nb_sample;
    int currentChannel;
    uchar phase;
    uint8_t size_of_u_sample,size_of_i_sample;
    float coeff_u,coeff_i;
    float i_scale_old;
    uint16_t zero_cross_index;
    double x[4096];
    double tab_voltage[4096];
    double tab_voltage_temp[4096];
    double tab_current[4096];
    double tab_current_temp[4096];
    ManageSerialPort *serialCom;
    RefreshTimer *commonRefreshTimer;
    Module *power_module;
    QPushButton *export_as;
    QPushButton *play_pause;

    QButtonGroup *chan_b_group;
    QRadioButton *chan1;
    QRadioButton *chan2;
    QRadioButton *chan3;
    QRadioButton *chan4;
    QRadioButton *chan5;
    QRadioButton *chan6;
    QGroupBox *box_layout_v2;
    QLabel *powerValue;
    QLabel *apparentPowerValue;
    QLabel *reactivePowerValue;
    QLabel *voltageValue;
    QLabel *currentValue;
    QLabel *powerFactorValue;

    void update_waveform();
    void update_value();

/*
protected:
    virtual void resizeEvent( QResizeEvent * );*/

private slots:
    void closeEvent(QCloseEvent *event);
    //refresh
    void timerSlot();
    void export_file();
    void switchPauseRefresh();
    void select_channel(int channel);


};



#endif // WAVEFORM_H
