#ifndef WIRELESSMODULE2_H
#define WIRELESSMODULE2_H

#include "manageserialport.h"
#include "refreshtimer.h"
class WirelessModule2 : public QWidget
{
    Q_OBJECT
public:
    explicit WirelessModule2(ManageSerialPort *_serialPort, RefreshTimer *_commonRefreshTimer, Module *_wireless_Module, bool _advancedUserMode, QWidget *parent = 0);

signals:
    void backToMainWindow();

public slots:
    void backToManageModule();
    void setadvance();
   /* void valueChanged(int row, int column);
    void comboBoxChanged(int _row);
    void sensorNbButtonClicked();
    void timerSlot();*/
    void get_data_clicked();
    void set_start_clicked();
    void dump_clicked();
    void valueChanged(int row, int column);
    void delete_row(int row);
    void select_changed(int row);
   // void date_time_changed(int row);
    void start_campaign_clicked();
    void refresh_values();
private:
    bool get_data();
    ManageSerialPort *serialCom;
    RefreshTimer *commonRefreshTimer;
    Module *wireless_Module;
    bool firstRefresh;
    bool fillingSensorTable;
    bool advancedUserMode;
    bool refresh_active;


    void setSerialNb(int row);

    typedef struct
    {
        uint16_t serialNb;
        uint16_t relay;
        uint8_t rssi;
        QDateTime date_dernier_vidage;
        uint8_t last_com;
    }sensor_w;

    sensor_w list_sensor_w[64];
    uint8_t pointeur_list_sensor_w;

    typedef struct
    {
        uint16_t serialNb;
        bool file_open;
    }sensor_vidage;

    QStringList batt_volt,batt_volt2;

    QFile tsvFile[64];
    QTextStream tsvFileStream[64];

    uint16_t list_sensor_vidage[64];
    uint8_t pointeur_list_sensor_vidage;


    bool openFile(uint8_t row);

    bool updateFile();

    uchar buffer_page[528];
     QSignalMapper *signalMapper;
    //graphics elements :
    void fillWindow();
    void setTableWidget();
    void add_empty_row();
    QVBoxLayout *globalLayout;
    QGroupBox *groupBoxWireless;
    QVBoxLayout *verticalLayout;
        QTableWidget *sensorTableWidget;
            QTableWidgetItem *sensorSNTableItem;
            QTableWidgetItem *sensorRelayTableItem;
            QTableWidgetItem *sensorNameTableItem;
            QTableWidgetItem *sensorRSSITableItem;
            QTableWidgetItem *sensorDateVTableItem;
            QTableWidgetItem *sensorLastComTableItem;
            QTableWidgetItem *sensorSelectTableItem;

             QCheckBox *select_sensor[256];
             QDateTimeEdit *date_vidage_sensor;
             QDateTimeEdit *start_date_sensor;
             QPushButton *set_date;
             QPushButton *start_vidage;
             QPushButton *get_file;


             QPushButton *start_campaign;
             QPushButton *refresh_list;
        QHBoxLayout *buttonLayout;
        QHBoxLayout *buttonLayout2;
            QPushButton *returnButton;


                QTableWidgetItem *sensorItemTable [256][256] ;
};

#endif // WIRELESSMODULE2_H


